/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package test;

import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.util.Calendar;
import java.util.concurrent.TimeUnit;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.jcr.Binary;
import javax.jcr.Node;
import javax.jcr.NodeIterator;
import javax.jcr.PathNotFoundException;
import javax.jcr.Property;
import javax.jcr.PropertyIterator;
import javax.jcr.Repository;
import javax.jcr.RepositoryException;
import javax.jcr.Session;
import javax.jcr.SimpleCredentials;
import javax.jcr.Value;
import org.modeshape.common.collection.Problem;
import org.modeshape.graph.Graph;
import org.modeshape.graph.connector.RepositorySourceException;
import org.modeshape.jcr.JcrConfiguration;
import org.modeshape.jcr.JcrEngine;
import org.modeshape.jcr.api.SecurityContext;
import org.modeshape.jcr.api.SecurityContextCredentials;

import org.xml.sax.SAXException;

/**
 *
 * @author danny
 */
public class Main {

    /**
     * @param args the command line arguments
     */
       JcrConfiguration jcrConfiguration = null;
       JcrEngine jcrEngine = null;
       Repository repository = null;
       Session session = null;
       Node nodeRoot = null;
       Node node = null;

       String file = "C:/test/modeshape/data/resources/configRepository.xml";
       String repo = "UFOs";

    public static void main(String[] args) {
        Main app = new Main();
        app.test();
    }

 

    public void test(){
        try {
            jcrConfiguration = new JcrConfiguration();
            jcrConfiguration.loadFrom(file);
            if (!jcrConfiguration.getProblems().isEmpty()) {
                for (Problem problem : jcrConfiguration.getProblems()) {
                    Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, problem);// Report these problems!
                }
            }

            jcrEngine = jcrConfiguration.build();
            jcrEngine.start();
            repository = jcrEngine.getRepository(repo);

            SecurityContext securityContext = new SecurityContext( ) {

                public String getUserName() {
                    return "admin";
                }

                public boolean hasRole(String string) {
                    return true;
                }

                public void logout() {

                }
            };

            //Starting JCR 
            SecurityContextCredentials credential = new SecurityContextCredentials(securityContext);
            session  = repository.login(credential);
                
                
            //***** The error of "jcr:createdBy" is shown by runnning  [Creating new Folder] or [Creating new File]  
            //***** for testing , pls uncomment either [Creating new Folder] or [Creating new File] block of codes , pls ignore the rest of the graph api function below *********  
                   
            //////////////////////////////////////////// [ Creating new Folder ] /////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
            Node root = session.getRootNode();
            Node folder= root.addNode("newfolder","nt:folder");
            dump(root);   //dump() is a custom function written to dump the  repository nodes and its properties
            session.save();
          
          
            //////////////////////////////////////////// [ Creating new File ] /////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
            //Node root = session.getRootNode();
            //Node file= root.addNode("newfile.txt","nt:file");
            //Node fileContent = file.addNode("jcr:content","mode:resource");
            //fileContent.setProperty("jcr:data", "testing");
            //fileContent.setProperty("jcr:mimeType","text/plain");
            //dump(root);   //dump() is a custom function written to dump the  repository nodes and its properties
            //session.save();
          
          
          
            //Stoping JCR 
            session.logout();
            jcrEngine.shutdown();
            jcrEngine.awaitTermination(5, TimeUnit.SECONDS);
            System.out.println("-Shutdown-");

            

        } catch (RepositoryException ex) {
            Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);
        } catch (InterruptedException ex) {
            Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);
        } catch (SAXException ex) {
            Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);
        } finally {
            jcrEngine.shutdown();
        }

    }

    public void createFolder(String path){
        try{
         Graph graph = jcrEngine.getGraph(repo);
            graph.create(path).with("jcr:primaryType","nt:folder").and();
        } catch (RepositorySourceException ex) {
            //Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);

        }
    }

     public void delete(String path){
        try{
            Graph graph = jcrEngine.getGraph(repo);
            graph.delete(path);
        } catch (Exception ex) {
            //Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);

        }
    }

    public void createFile(String path,byte[] data){
        try{
         Graph graph = jcrEngine.getGraph(repo);
            graph.create(path).with("jcr:primaryType","nt:file").and();
            graph.create(path+"/jcr:content").with("jcr:primaryType","nt:resource").and("jcr:data",data)
             .orReplace()
             .and();
        } catch (RepositorySourceException ex) {
            //Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);

        }
    }

    private static void dump(Node node) throws RepositoryException {
        // First output the node path
        System.out.println(node.getPath());
        // Skip the virtual (and large!) jcr:system subtree
        if (node.getName().equals("jcr:system")) {
            return;
        }

        // Then output the properties
        PropertyIterator properties = node.getProperties();
        while (properties.hasNext()) {
            Property property = properties.nextProperty();
            if (property.getDefinition().isMultiple()) {
                // A multi-valued property, print all values
                Value[] values = property.getValues();
                for (int i = 0; i < values.length; i++) {
                    System.out.println(
                        property.getPath() + " = " + values[i].getString());
                }
            } else {
                // A single-valued property
                System.out.println(
                    property.getPath() + " = " + property.getString());
            }
        }

        // Finally output all the child nodes recursively
        NodeIterator nodes = node.getNodes();
        while (nodes.hasNext()) {
            dump(nodes.nextNode());
        }
    }

}
